Index: /trunk/include/ws_functions/pwg.permissions.php
===================================================================
--- /trunk/include/ws_functions/pwg.permissions.php	(revision 25281)
+++ /trunk/include/ws_functions/pwg.permissions.php	(revision 25281)
@@ -0,0 +1,235 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2013 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+/**
+ * API method
+ * Returns permissions
+ * @param mixed[] $params
+ *    @option int[] cat_id (optional)
+ *    @option int[] group_id (optional)
+ *    @option int[] user_id (optional)
+ */
+function ws_permissions_getList($params, &$service)
+{
+  $my_params = array_intersect(array_keys($params), array('cat_id','group_id','user_id'));
+  if (count($my_params) > 1)
+  {
+    return new PwgError(WS_ERR_INVALID_PARAM, 'Too many parameters, provide cat_id OR user_id OR group_id');
+  }
+
+  $cat_filter = '';
+  if (!empty($params['cat_id']))
+  {
+    $cat_filter = 'WHERE cat_id IN('. implode(',', $params['cat_id']) .')';
+  }
+
+  $perms = array();
+
+  // direct users
+  $query = '
+SELECT user_id, cat_id
+  FROM '. USER_ACCESS_TABLE .'
+  '. $cat_filter .'
+;';
+  $result = pwg_query($query);
+
+  while ($row = pwg_db_fetch_assoc($result))
+  {
+    if (!isset($perms[ $row['cat_id'] ]))
+    {
+      $perms[ $row['cat_id'] ]['id'] = $row['cat_id'];
+    }
+    $perms[ $row['cat_id'] ]['users'][] = $row['user_id'];
+  }
+
+  // indirect users
+  $query = '
+SELECT ug.user_id, ga.cat_id
+  FROM '. USER_GROUP_TABLE .' AS ug
+    INNER JOIN '. GROUP_ACCESS_TABLE .' AS ga
+    ON ug.group_id = ga.group_id
+  '. $cat_filter .'
+;';
+  $result = pwg_query($query);
+
+  while ($row = pwg_db_fetch_assoc($result))
+  {
+    if (!isset($perms[ $row['cat_id'] ]))
+    {
+      $perms[ $row['cat_id'] ]['id'] = $row['cat_id'];
+    }
+    $perms[ $row['cat_id'] ]['users_indirect'][] = $row['user_id'];
+  }
+
+  // groups
+  $query = '
+SELECT group_id, cat_id
+  FROM '. GROUP_ACCESS_TABLE .'
+  '. $cat_filter .'
+;';
+  $result = pwg_query($query);
+
+  while ($row = pwg_db_fetch_assoc($result))
+  {
+    if (!isset($perms[ $row['cat_id'] ]))
+    {
+      $perms[ $row['cat_id'] ]['id'] = $row['cat_id'];
+    }
+    $perms[ $row['cat_id'] ]['groups'][] = $row['group_id'];
+  }
+
+  // filter by group and user
+  foreach ($perms as $cat_id => &$cat)
+  {
+    if (isset($filters['group_id']))
+    {
+      if (empty($cat['groups']) or count(array_intersect($cat['groups'], $params['group_id'])) == 0)
+      {
+        unset($perms[$cat_id]);
+        continue;
+      }
+    }
+    if (isset($filters['user_id']))
+    {
+      if (
+        (empty($cat['users_indirect']) or count(array_intersect($cat['users_indirect'], $params['user_id'])) == 0)
+        and (empty($cat['users']) or count(array_intersect($cat['users'], $params['user_id'])) == 0)
+      ) {
+        unset($perms[$cat_id]);
+        continue;
+      }
+    }
+
+    $cat['groups'] = !empty($cat['groups']) ? array_unique($cat['groups']) : array();
+    $cat['users'] = !empty($cat['users']) ? array_unique($cat['users']) : array();
+    $cat['users_indirect'] = !empty($cat['users_indirect']) ? array_unique($cat['users_indirect']) : array();
+  }
+  unset($cat);
+
+  return array(
+    'categories' => new PwgNamedArray(
+      array_values($perms),
+      'category',
+      array('id')
+      )
+    );
+}
+
+/**
+ * API method
+ * Add permissions
+ * @param mixed[] $params
+ *    @option int[] cat_id
+ *    @option int[] group_id (optional)
+ *    @option int[] user_id (optional)
+ *    @option bool recursive
+ */
+function ws_permissions_add($params, &$service)
+{
+  include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+
+  if (!empty($params['group_id']))
+  {
+    $cat_ids = get_uppercat_ids($params['cat_id']);
+    if ($params['recursive'])
+    {
+      $cat_ids = array_merge($cat_ids, get_subcat_ids($params['cat_id']));
+    }
+
+    $query = '
+SELECT id
+  FROM '. CATEGORIES_TABLE .'
+  WHERE id IN ('. implode(',', $cat_ids) .')
+    AND status = \'private\'
+;';
+    $private_cats = array_from_query($query, 'id');
+
+    $inserts = array();
+    foreach ($private_cats as $cat_id)
+    {
+      foreach ($params['group_id'] as $group_id)
+      {
+        $inserts[] = array(
+          'group_id' => $group_id,
+          'cat_id' => $cat_id
+          );
+      }
+    }
+
+    mass_inserts(
+      GROUP_ACCESS_TABLE,
+      array('group_id','cat_id'),
+      $inserts,
+      array('ignore'=>true)
+      );
+  }
+
+  if (!empty($params['user_id']))
+  {
+    if ($params['recursive']) $_POST['apply_on_sub'] = true;
+    add_permission_on_category($params['cat_id'], $params['user_id']);
+  }
+
+  return $service->invoke('pwg.permissions.getList', array('cat_id'=>$params['cat_id']));
+}
+
+/**
+ * API method
+ * Removes permissions
+ * @param mixed[] $params
+ *    @option int[] cat_id
+ *    @option int[] group_id (optional)
+ *    @option int[] user_id (optional)
+ */
+function ws_permissions_remove($params, &$service)
+{
+  include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+
+  $cat_ids = get_subcat_ids($params['cat_id']);
+
+  if (!empty($params['group_id']))
+  {
+    $query = '
+DELETE
+  FROM '. GROUP_ACCESS_TABLE .'
+  WHERE group_id IN ('. implode(',', $params['group_id']).')
+    AND cat_id IN ('. implode(',', $cat_ids).')
+;';
+    pwg_query($query);
+  }
+
+  if (!empty($params['user_id']))
+  {
+    $query = '
+DELETE
+  FROM '. USER_ACCESS_TABLE .'
+  WHERE user_id IN ('. implode(',', $params['user_id']) .')
+    AND cat_id IN ('. implode(',', $cat_ids) .')
+;';
+    pwg_query($query);
+  }
+
+  return $service->invoke('pwg.permissions.getList', array('cat_id'=>$params['cat_id']));
+}
+
+?>
Index: /trunk/include/ws_functions/pwg.php
===================================================================
--- /trunk/include/ws_functions/pwg.php	(revision 25281)
+++ /trunk/include/ws_functions/pwg.php	(revision 25281)
@@ -0,0 +1,338 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2013 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+/**
+ * API method
+ * Returns a list of missing derivatives (not generated yet)
+ * @param mixed[] $params
+ *    @option string types (optional)
+ *    @option int[] ids
+ *    @option int max_urls
+ *    @option int prev_page (optional)
+ */
+function ws_getMissingDerivatives($params, &$service)
+{
+  global $conf;
+
+  if (empty($params['types']))
+  {
+    $types = array_keys(ImageStdParams::get_defined_type_map());
+  }
+  else
+  {
+    $types = array_intersect(array_keys(ImageStdParams::get_defined_type_map()), $params['types']);
+    if (count($types)==0)
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, "Invalid types");
+    }
+  }
+
+  $max_urls = $params['max_urls'];
+  $query = 'SELECT MAX(id)+1, COUNT(*) FROM '. IMAGES_TABLE .';';
+  list($max_id, $image_count) = pwg_db_fetch_row(pwg_query($query));
+
+  if (0 == $image_count)
+  {
+    return array();
+  }
+
+  $start_id = $params['prev_page'];
+  if ($start_id<=0)
+  {
+    $start_id = $max_id;
+  }
+
+  $uid = '&b='.time();
+
+  $conf['question_mark_in_urls'] = $conf['php_extension_in_urls'] = true;
+  $conf['derivative_url_style'] = 2; //script
+
+  $qlimit = min(5000, ceil(max($image_count/500, $max_urls/count($types))));
+  $where_clauses = ws_std_image_sql_filter( $params, '' );
+  $where_clauses[] = 'id<start_id';
+
+  if (!empty($params['ids']))
+  {
+    $where_clauses[] = 'id IN ('.implode(',',$params['ids']).')';
+  }
+
+  $query_model = '
+SELECT id, path, representative_ext, width, height, rotation
+  FROM '. IMAGES_TABLE .'
+  WHERE '. implode(' AND ', $where_clauses) .'
+  ORDER BY id DESC
+  LIMIT '. $qlimit .'
+;';
+
+  $urls = array();
+  do
+  {
+    $result = pwg_query(str_replace('start_id', $start_id, $query_model));
+    $is_last = pwg_db_num_rows($result) < $qlimit;
+
+    while ($row=pwg_db_fetch_assoc($result))
+    {
+      $start_id = $row['id'];
+      $src_image = new SrcImage($row);
+      if ($src_image->is_mimetype())
+      {
+        continue;
+      }
+
+      foreach($types as $type)
+      {
+        $derivative = new DerivativeImage($type, $src_image);
+        if ($type != $derivative->get_type())
+        {
+          continue;
+        }
+        if (@filemtime($derivative->get_path())===false)
+        {
+          $urls[] = $derivative->get_url().$uid;
+        }
+      }
+
+      if (count($urls)>=$max_urls and !$is_last)
+      {
+        break;
+      }
+    }
+    if ($is_last)
+    {
+      $start_id = 0;
+    }
+  } while (count($urls)<$max_urls and $start_id);
+
+  $ret = array();
+  if ($start_id)
+  {
+    $ret['next_page'] = $start_id;
+  }
+  $ret['urls'] = $urls;
+  return $ret;
+}
+
+/**
+ * API method
+ * Returns Piwigo version
+ * @param mixed[] $params
+ */
+function ws_getVersion($params, &$service)
+{
+  global $conf;
+
+  if ($conf['show_version'] or is_admin())
+  {
+    return PHPWG_VERSION;
+  }
+  else
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+}
+
+/**
+ * API method
+ * Returns general informations about the installation
+ * @param mixed[] $params
+ */
+function ws_getInfos($params, &$service)
+{
+  $infos['version'] = PHPWG_VERSION;
+
+  $query = 'SELECT COUNT(*) FROM '.IMAGES_TABLE.';';
+  list($infos['nb_elements']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.CATEGORIES_TABLE.';';
+  list($infos['nb_categories']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.CATEGORIES_TABLE.' WHERE dir IS NULL;';
+  list($infos['nb_virtual']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.CATEGORIES_TABLE.' WHERE dir IS NOT NULL;';
+  list($infos['nb_physical']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.IMAGE_CATEGORY_TABLE.';';
+  list($infos['nb_image_category']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.TAGS_TABLE.';';
+  list($infos['nb_tags']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.IMAGE_TAG_TABLE.';';
+  list($infos['nb_image_tag']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.USERS_TABLE.';';
+  list($infos['nb_users']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.GROUPS_TABLE.';';
+  list($infos['nb_groups']) = pwg_db_fetch_row(pwg_query($query));
+
+  $query = 'SELECT COUNT(*) FROM '.COMMENTS_TABLE.';';
+  list($infos['nb_comments']) = pwg_db_fetch_row(pwg_query($query));
+
+  // first element
+  if ($infos['nb_elements'] > 0)
+  {
+    $query = 'SELECT MIN(date_available) FROM '.IMAGES_TABLE.';';
+    list($infos['first_date']) = pwg_db_fetch_row(pwg_query($query));
+  }
+
+  // unvalidated comments
+  if ($infos['nb_comments'] > 0)
+  {
+    $query = 'SELECT COUNT(*) FROM '.COMMENTS_TABLE.' WHERE validated=\'false\';';
+    list($infos['nb_unvalidated_comments']) = pwg_db_fetch_row(pwg_query($query));
+  }
+
+  foreach ($infos as $name => $value)
+  {
+    $output[] = array(
+      'name' => $name,
+      'value' => $value,
+    );
+  }
+
+  return array('infos' => new PwgNamedArray($output, 'item'));
+}
+
+/**
+ * API method
+ * Adds images to the caddie
+ * @param mixed[] $params
+ *    @option int[] image_id
+ */
+function ws_caddie_add($params, &$service)
+{
+  global $user;
+
+  $query = '
+SELECT id
+  FROM '. IMAGES_TABLE .'
+      LEFT JOIN '. CADDIE_TABLE .'
+      ON id=element_id AND user_id='. $user['id'] .'
+  WHERE id IN ('. implode(',',$params['image_id']) .')
+    AND element_id IS NULL
+;';
+  $result = array_from_query($query, 'id');
+
+  $datas = array();
+  foreach ($result as $id)
+  {
+    $datas[] = array(
+      'element_id' => $id,
+      'user_id' => $user['id'],
+      );
+  }
+  if (count($datas))
+  {
+    mass_inserts(
+      CADDIE_TABLE,
+      array('element_id','user_id'),
+      $datas
+      );
+  }
+  return count($datas);
+}
+
+/**
+ * API method
+ * Deletes rates of an user
+ * @param mixed[] $params
+ *    @option int user_id
+ *    @option string anonymous_id (optional)
+ */
+function ws_rates_delete($params, &$service)
+{
+  $query = '
+DELETE FROM '. RATE_TABLE .'
+  WHERE user_id='. $params['user_id'];
+
+  if (!empty($params['anonymous_id']))
+  {
+    $query .= ' AND anonymous_id=\''.$params['anonymous_id'].'\'';
+  }
+
+  $changes = pwg_db_changes(pwg_query($query));
+  if ($changes)
+  {
+    include_once(PHPWG_ROOT_PATH.'include/functions_rate.inc.php');
+    update_rating_score();
+  }
+  return $changes;
+}
+
+/**
+ * API method
+ * Performs a login
+ * @param mixed[] $params
+ *    @option string username
+ *    @option string password
+ */
+function ws_session_login($params, &$service)
+{
+  if (try_log_user($params['username'], $params['password'], false))
+  {
+    return true;
+  }
+  return new PwgError(999, 'Invalid username/password');
+}
+
+
+/**
+ * API method
+ * Performs a logout
+ * @param mixed[] $params
+ */
+function ws_session_logout($params, &$service)
+{
+  if (!is_a_guest())
+  {
+    logout_user();
+  }
+  return true;
+}
+
+/**
+ * API method
+ * Returns info about the current user
+ * @param mixed[] $params
+ */
+function ws_session_getStatus($params, &$service)
+{
+  global $user;
+
+  $res['username'] = is_a_guest() ? 'guest' : stripslashes($user['username']);
+  foreach ( array('status', 'theme', 'language') as $k )
+  {
+    $res[$k] = $user[$k];
+  }
+  $res['pwg_token'] = get_pwg_token();
+  $res['charset'] = get_pwg_charset();
+
+  list($dbnow) = pwg_db_fetch_row(pwg_query('SELECT NOW();'));
+  $res['current_datetime'] = $dbnow;
+
+  return $res;
+}
+
+?>
Index: /trunk/include/ws_functions/pwg.tags.php
===================================================================
--- /trunk/include/ws_functions/pwg.tags.php	(revision 25281)
+++ /trunk/include/ws_functions/pwg.tags.php	(revision 25281)
@@ -0,0 +1,244 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2013 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+/**
+ * API method
+ * Returns a list of tags
+ * @param mixed[] $params
+ *    @option bool sort_by_counter
+ */
+function ws_tags_getList($params, &$service)
+{
+  $tags = get_available_tags();
+  if ($params['sort_by_counter'])
+  {
+    usort($tags, create_function('$a,$b', 'return -$a["counter"]+$b["counter"];') );
+  }
+  else
+  {
+    usort($tags, 'tag_alpha_compare');
+  }
+
+  for ($i=0; $i<count($tags); $i++)
+  {
+    $tags[$i]['id'] = (int)$tags[$i]['id'];
+    $tags[$i]['counter'] = (int)$tags[$i]['counter'];
+    $tags[$i]['url'] = make_index_url(
+      array(
+        'section'=>'tags',
+        'tags'=>array($tags[$i])
+        )
+      );
+  }
+
+  return array(
+    'tags' => new PwgNamedArray(
+      $tags,
+      'tag',
+      ws_std_get_tag_xml_attributes()
+      )
+    );
+}
+
+/**
+ * API method
+ * Returns the list of tags as you can see them in administration
+ * @param mixed[] $params
+ *
+ * Only admin can run this method and permissions are not taken into
+ * account.
+ */
+function ws_tags_getAdminList($params, &$service)
+{
+  return array(
+    'tags' => new PwgNamedArray(
+      get_all_tags(),
+      'tag',
+      ws_std_get_tag_xml_attributes()
+      )
+    );
+}
+
+/**
+ * API method
+ * Returns a list of images for tags
+ * @param mixed[] $params
+ *    @option int[] tag_id (optional)
+ *    @option string[] tag_url_name (optional)
+ *    @option string[] tag_name (optional)
+ *    @option bool tag_mode_and
+ *    @option int per_page
+ *    @option int page
+ *    @option string order
+ */
+function ws_tags_getImages($params, &$service)
+{
+  // first build all the tag_ids we are interested in
+  $tags = find_tags($params['tag_id'], $params['tag_url_name'], $params['tag_name']);
+  $tags_by_id = array();
+  foreach ($tags as $tag)
+  {
+    $tags['id'] = (int)$tag['id'];
+    $tags_by_id[ $tag['id'] ] = $tag;
+  }
+  unset($tags);
+  $tag_ids = array_keys($tags_by_id);
+
+  $where_clauses = ws_std_image_sql_filter($params);
+  if (!empty($where_clauses))
+  {
+    $where_clauses = implode(' AND ', $where_clauses);
+  }
+
+  $image_ids = get_image_ids_for_tags(
+    $tag_ids,
+    $params['tag_mode_and'] ? 'AND' : 'OR',
+    $where_clauses,
+    ws_std_image_sql_order($params)
+    );
+
+  $count_set = count($image_ids);
+  $image_ids = array_slice($image_ids, $params['per_page']*$params['page'], $params['per_page'] );
+
+  $image_tag_map = array();
+  // build list of image ids with associated tags per image
+  if (!empty($image_ids) and !$params['tag_mode_and'])
+  {
+    $query = '
+SELECT image_id, GROUP_CONCAT(tag_id) AS tag_ids
+  FROM '. IMAGE_TAG_TABLE .'
+  WHERE tag_id IN ('. implode(',', $tag_ids) .')
+    AND image_id IN ('. implode(',', $image_ids) .')
+  GROUP BY image_id
+;';
+    $result = pwg_query($query);
+
+    while ($row = pwg_db_fetch_assoc($result))
+    {
+      $row['image_id'] = (int)$row['image_id'];
+      $image_ids[] = $row['image_id'];
+      $image_tag_map[ $row['image_id'] ] = explode(',', $row['tag_ids']);
+    }
+  }
+
+  $images = array();
+  if (!empty($image_ids))
+  {
+    $rank_of = array_flip($image_ids);
+
+    $query = '
+SELECT *
+  FROM '. IMAGES_TABLE .'
+  WHERE id IN ('. implode(',',$image_ids) .')
+;';
+    $result = pwg_query($query);
+
+    while ($row = pwg_db_fetch_assoc($result))
+    {
+      $image = array();
+      $image['rank'] = $rank_of[ $row['id'] ];
+
+      foreach (array('id', 'width', 'height', 'hit') as $k)
+      {
+        if (isset($row[$k]))
+        {
+          $image[$k] = (int)$row[$k];
+        }
+      }
+      foreach (array('file', 'name', 'comment', 'date_creation', 'date_available') as $k)
+      {
+        $image[$k] = $row[$k];
+      }
+      $image = array_merge( $image, ws_std_get_urls($row) );
+
+      $image_tag_ids = ($params['tag_mode_and']) ? $tag_ids : $image_tag_map[$image['id']];
+      $image_tags = array();
+      foreach ($image_tag_ids as $tag_id)
+      {
+        $url = make_index_url(
+          array(
+            'section'=>'tags',
+            'tags'=> array($tags_by_id[$tag_id])
+            )
+          );
+        $page_url = make_picture_url(
+          array(
+            'section'=>'tags',
+            'tags'=> array($tags_by_id[$tag_id]),
+            'image_id' => $row['id'],
+            'image_file' => $row['file'],
+            )
+          );
+        $image_tags[] = array(
+          'id' => (int)$tag_id,
+          'url' => $url,
+          'page_url' => $page_url,
+          );
+      }
+
+      $image['tags'] = new PwgNamedArray($image_tags, 'tag', ws_std_get_tag_xml_attributes() );
+      $images[] = $image;
+    }
+
+    usort($images, 'rank_compare');
+    unset($rank_of);
+  }
+
+  return array(
+    'paging' => new PwgNamedStruct(
+      array(
+        'page' => $params['page'],
+        'per_page' => $params['per_page'],
+        'count' => count($images),
+        'total_count' => $count_set,
+        )
+      ),
+    'images' => new PwgNamedArray(
+      $images,
+      'image',
+      ws_std_get_image_xml_attributes()
+      )
+    );
+}
+
+/**
+ * API method
+ * Adds a tag
+ * @param mixed[] $params
+ *    @option string name
+ */
+function ws_tags_add($params, &$service)
+{
+  include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+
+  $creation_output = create_tag($params['name']);
+
+  if (isset($creation_output['error']))
+  {
+    return new PwgError(500, $creation_output['error']);
+  }
+
+  return $creation_output;
+}
+
+?>
